/*
 * @(#)CreateDirDialog.java	
 * Copyright (c) 1997 Advent Network Management, Inc. All Rights Reserved.
 * Please read the associated COPYRIGHTS file for more details.
 * 
 * ADVENT NETWORK MANAGEMENT, INC. MAKES NO REPRESENTATIONS OR WARRANTIES 
 * ABOUT THE SUITABILITY OF THE SOFTWARE, EITHER EXPRESS OR IMPLIED, 
 * INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, 
 * FITNESS FOR A PARTICULAR PURPOSE, OR NON-INFRINGEMENT.  ADVENT NETWORK 
 * MANAGEMENT, INC. SHALL NOT BE LIABLE FOR ANY DAMAGES SUFFERED BY 
 * LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING THIS SOFTWARE 
 * OR ITS DERIVATIVES.
 */

import java.applet.*;
import java.awt.*;
import java.util.*;

public class CreateDirDialog extends Frame {
  LabeledTextField ltf =null;
  ButtonPanel ok_close =null;

  public SasClientFunction sframe; // The frame that provides the OK function

  Font fontb = new Font("Helvetica", Font.BOLD, 16);
  Font font = new Font("Helvetica", Font.PLAIN, 16);
  String advent = new String("Advent Create Directory Dialog");

/* This takes care of the look of CreateDirDialog */
  public CreateDirDialog(String title, boolean modal, String prompt, String defaulttext, int txtlength) { 

    super();
    setTitle(new String(title + " : " + advent));
    setBackground(Color.lightGray);
    setLayout(new BorderLayout());
    ltf = new LabeledTextField(prompt,defaulttext,txtlength);
    add("Center", ltf);
    String buttons[] = {"OK","Cancel"};
    ok_close = new ButtonPanel(buttons);
    add("South", ok_close);
    setFont(fontb, font);
    resize(550,200);
   // setBackground(Title.fadedBlue);
  }

/* set all the individual fonts */
  public void setFont(Font fontb, Font font) {
    if (ltf != null)  ltf.setFont(fontb, font);
    if (ok_close != null)  ok_close.setFont(fontb);
    super.setFont(fontb);
  }

  boolean loading = false;  // to avoid loading MIBs twice

/* for OK and CANCEL actions */
  public boolean action(Event e, Object arg) {
	if (loading) return false;
	if (e.target instanceof Button) {
            if (arg.equals("Cancel")) this.hide();
            else if (arg.equals("OK")) {
		loading = true;
		setCursor(WAIT_CURSOR);
		((SasClientFunction)sframe).createDir(ltf.textfield.getText());
		setCursor(DEFAULT_CURSOR);
		this.hide();
	    }
        }
	if (e.target instanceof TextField) {
		loading = true;
		setCursor(WAIT_CURSOR);
		((SasClientFunction)sframe).createDir(ltf.textfield.getText());
		setCursor(DEFAULT_CURSOR);
		this.hide();
        }
    return true;
  }

/** Allow another MIB load only if shown again */
  public synchronized void show() {
    loading = false;
    super.show();
  }

  /** To handle destroy window - pass all else to parent */
  public boolean handleEvent(Event e) {
    if (e.id == Event.WINDOW_DESTROY) {
		hide();
    }
    return super.handleEvent(e);
  }

}

