/*
 * @(#)LabeledTextField.java	
 * Copyright (c) 1997 Advent Network Management, Inc. All Rights Reserved.
 * Please read the associated COPYRIGHTS file for more details.
 * 
 * ADVENT NETWORK MANAGEMENT, INC. MAKES NO REPRESENTATIONS OR WARRANTIES 
 * ABOUT THE SUITABILITY OF THE SOFTWARE, EITHER EXPRESS OR IMPLIED, 
 * INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, 
 * FITNESS FOR A PARTICULAR PURPOSE, OR NON-INFRINGEMENT.  ADVENT NETWORK 
 * MANAGEMENT, INC. SHALL NOT BE LIABLE FOR ANY DAMAGES SUFFERED BY 
 * LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING THIS SOFTWARE 
 * OR ITS DERIVATIVES.
 */

import java.awt.*;
import java.util.*;

public class LabeledTextField extends Panel {

  public Label label;
  public TextField textfield;

  public LabeledTextField(String labelText) {
    label = new Label(labelText);
    textfield = new TextField(3*labelText.length());  // Some arbitrary length
    thisLayout();
  }

  public LabeledTextField(String labelText, String tfText) {
    label = new Label(labelText);
    textfield = new TextField(tfText);  // Some arbitrary length
    thisLayout();
  }

  public LabeledTextField(String labelText, int length) {
    label = new Label(labelText);
    textfield = new TextField(length);  // Some arbitrary length
    thisLayout();
  }

  public LabeledTextField(String labelText, String tfText, int length) {
    label = new Label(labelText);
    textfield = new TextField(tfText,length);  
    thisLayout();
  }

  void thisLayout() {
    setLayout(new FlowLayout(FlowLayout.LEFT));
    add(label);
    add(textfield);
  }
  
  public void setFont(Font fontb, Font font) {
    textfield.setFont(font);
    label.setFont(fontb);
  }

}

