/*
 * @(#)SaveFileDialog.java	
 * Copyright (c) 1997 Advent Network Management, Inc. All Rights Reserved.
 * Please read the associated COPYRIGHTS file for more details.
 * 
 * ADVENT NETWORK MANAGEMENT, INC. MAKES NO REPRESENTATIONS OR WARRANTIES 
 * ABOUT THE SUITABILITY OF THE SOFTWARE, EITHER EXPRESS OR IMPLIED, 
 * INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, 
 * FITNESS FOR A PARTICULAR PURPOSE, OR NON-INFRINGEMENT.  ADVENT NETWORK 
 * MANAGEMENT, INC. SHALL NOT BE LIABLE FOR ANY DAMAGES SUFFERED BY 
 * LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING THIS SOFTWARE 
 * OR ITS DERIVATIVES.
 */

import java.applet.*;
import java.awt.*;
import java.util.*;

public class SaveFileDialog extends Frame {
  
  public SasClientFunction sframe; // The frame that provides the OK function

  Font fontb = new Font("Helvetica", Font.BOLD, 16);
  Font font = new Font("Helvetica", Font.PLAIN, 16);
  String advent = new String("Advent Save File Dialog");

  TextField field;
  TextArea text;
  

/* This takes care of the look of SaveFileDialog */
  public SaveFileDialog() {

    super();
    setTitle(new String(advent));
    setBackground(Color.lightGray);

    GridBagLayout gridbag = new GridBagLayout();  // we'll use gridbag
    GridBagConstraints c = new GridBagConstraints();
    setLayout(gridbag);
    c.fill = GridBagConstraints.BOTH;
    c.weightx = 1.0;
    c.insets = new Insets(20,10,0,10);
    
    c.gridwidth = GridBagConstraints.REMAINDER;
    Label label = new Label("Enter the Text to be Saved");label.setFont(fontb);
    gridbag.setConstraints(label,c);
    add(label);

    c.insets = new Insets(0,10,10,10);
    c.gridwidth = GridBagConstraints.REMAINDER;
    text = new TextArea();
    text.setEditable(true);
    gridbag.setConstraints(text,c);
    add(text);


    c.gridwidth = 1;
    label = new Label("Enter File Name to be saved");label.setFont(fontb);
    gridbag.setConstraints(label,c);
    add(label);

    c.gridwidth = GridBagConstraints.REMAINDER;
    field = new TextField();
    field.setEditable(true);
    gridbag.setConstraints(field,c);
    add(field);

    	// Bottom panel is a panel sub-class we've defined for a row of buttons
    c.weighty = 0.0;
    c.gridheight = 1;
    String buttons[] = {"Save Text", "Cancel"};
    ButtonPanel bp = new ButtonPanel(buttons);
    bp.setFont(fontb);
    gridbag.setConstraints(bp,c);
    add(bp);



    resize(550,400);
   // setBackground(Title.fadedBlue);
  }


/* for OK and CANCEL actions */
  public boolean action(Event e, Object arg) {
	if (e.target instanceof Button) {
            if (arg.equals("Cancel")) this.hide();
            else if (arg.equals("Save Text")) {
		setCursor(WAIT_CURSOR);
		((SasClientFunction)sframe).saveFile(text.getText(),field.getText());
		setCursor(DEFAULT_CURSOR);
		this.hide();
	    }
        else if (arg.equals("Append Text")) {
		setCursor(WAIT_CURSOR);
		((SasClientFunction)sframe).saveFile(text.getText(),field.getText());
		setCursor(DEFAULT_CURSOR);
		this.hide();
        }        
    }
    return true;
  }

/** Allow another MIB load only if shown again */
  public synchronized void show() {
    super.show();
  }

/** To handle destroy window - pass all else to parent */
  public boolean handleEvent(Event e) {
    if (e.id == Event.WINDOW_DESTROY) {
		hide();
    }
    return super.handleEvent(e);
  }


}

