package MCSocket;

import java.io.*;
import java.net.*;

/**
 * This class implements server socket using datagram packet to
 * exchange data.
 * <br>
 * A server socket waits for requests to come from network.
 *
 * @author    Michele Malgeri
 * @version  %I%, %G%
 * @since    MAP2.0
 *
 */
 
public class MServerSocket extends Thread {
  private int BACKLOG = 0;
  private int port;
  private int backlog;
  private InetAddress bindAddress;
  private queueManager qm;
  private connectionManager cm;      
  /**
   *    Constructor
   *
   *    @param  port  
   *    @param  backlog
   *    @param  bindAddress
   *
   *    
   */
  public MServerSocket(int port, int backlog, InetAddress bindAddress) throws IOException {
    this.port = port;
    this.backlog = backlog;
    this.bindAddress = bindAddress; 

    cm = new connectionManager();
    Queue q = new Queue();
  
    socketManager sm = new socketManager(port, backlog, bindAddress, cm);
    sm.start();
  }
  
  /**
   *    Constructor. Bind address defaults to 224.0.0.1
   *
   *    @param  port  
   *    
   */
  public MServerSocket(int port) throws IOException {
    this(port, 0, InetAddress.getByName("224.0.0.1"));
  }
  
  public MSocket accept() throws IOException {
    // gestisce l'attesa di una nuova connessione
    return cm.getNewConnection();
  }
  
  public void close() throws IOException {
  }
  
  public String toString() {
    return "MServerSocket " + bindAddress;
  }
}