package MCSocket;

import java.util.Vector;

public class Queue extends Vector {
  
  Queue(int initialCapacity, int capacityIncrement) {
    super(initialCapacity, capacityIncrement);
  }
  
  Queue() {
    this(5, 5);
  }
  
  public synchronized void insert(Object o) {
    addElement(o);
    // queue contains al least one element, thus remove can
    // be unlocked
    notifyAll();
  }
  
  public synchronized Object remove() {
    //
    // No element containes, wait until some elements are present
    //
    try {
      while(isEmpty())
        wait();
    } catch(InterruptedException e) {
        System.err.println("qm get() InterruptedException"); 
      }

    Object o = firstElement();
    removeElement(o);
    return o;
  }
  
  public synchronized Object peek() {
    if(isEmpty())
      return null;
    return firstElement();
  }
}