package MCSocket;

import java.util.*;
import java.net.*;
import java.io.*;

public class connectionManager {
  private Hashtable ht = new Hashtable();
  private Queue cq = new Queue();
  
  public MSocket getNewConnection() {
    return (MSocket) cq.remove();
  }
  
  private void putNewConnection(MSocket socket) {
    cq.insert(socket);
  }
  
  public synchronized void put(InetAddress address, int port, MSocket socket) {
    try {
      URL url = new URL("http", address.getHostAddress(), port, "");
      if(ht.containsKey(url)) {
      }
      else
        ht.put(url, socket);
        putNewConnection(socket);
    } catch(MalformedURLException e) {
        System.err.println("ERROR (queueManager): MalformedURLException");
      }
  }
  
  public synchronized MSocket get(InetAddress address, int port) {
    try {
      URL url = new URL("http", address.getHostAddress(), port, "");
      MSocket socket = (MSocket) ht.get(url);
      if(socket == null)
        System.err.println("ERROR (queueManager): can't find socket");
        
      return socket; 
    } catch(MalformedURLException e) {
        System.err.println("ERROR (queueManager): MalformedURLException");
      }
    return null;
  }

  public synchronized void remove(InetAddress address, int port) {
    try {
      if(config.DEBUG)
        System.out.println("DEBUG (connectionManager): removing "
                            + address
                            + " "
                            + port);
      URL url = new URL("http", address.getHostAddress(), port, "");
      ht.remove(url);
    } catch(MalformedURLException e) {
        System.err.println("ERROR (queueManager): MalformedURLException");
      }
  }

  public synchronized void close() throws IOException {

    MSocket socket;

    //byte[] buf = new byte[1024];
    //buf[0] = 0;
    //buf[1] = 1;

    //DatagramPacket dp = new DatagramPacket(buf, buf.length, InetAddress.getByName("0.0.0.0"), 0));
    for(Enumeration e = ht.elements(); e.hasMoreElements(); ) {
      socket = (MSocket) e.nextElement();
      //socket.getQueue().insert(dp);
      socket.close();
    }

  }      
}