package MCSocket;

import java.net.*;
import java.io.*;
import java.lang.Thread;

/**
 *  
 */
 
public class socketManager extends Thread {
  //private MSocket socket;
  private DatagramPacket dp;
  private byte[] buf = new byte[config.SIZE];
  private int port;
  private InetAddress bindAddress;
  //private Queue q;
  private connectionManager cm;
  private int backlog;
  private DatagramSocket ds;
  //private MulticastSocket dg;
      
  socketManager(int port, int backlog, InetAddress bindAddress, connectionManager cm) 
                                                                      throws IOException {
    this.cm = cm;
    this.port = port;
    this.bindAddress = bindAddress;
    this.backlog = backlog;

    //socket = new MSocket(bindAddress, port);

    dp = new DatagramPacket(buf, buf.length);      
 
    if(bindAddress.isMulticastAddress()) {
      ds = new MulticastSocket(port);
      ((MulticastSocket) ds).joinGroup(bindAddress);
    }
    else 
      ds = new DatagramSocket(port);
  }
  
  /**
   *  Constructor used to immediately restart listening on socket
   *
   *  @param  socket
   *  @param  q
   *
   */
  socketManager(DatagramSocket ds, connectionManager cm) throws IOException {
    this.ds = ds;
    this.cm = cm;
    this.bindAddress = ds.getLocalAddress();
    dp = new DatagramPacket(buf, buf.length);      
  }
    
  public void run() {
    if(config.DEBUG) System.out.println("DEBUG (socketManager): running on "
                                        + ds);
    
    try {
      ds.receive(dp);
      if(config.DEBUG) 
        System.out.println("DEBUG (socketManager): packet received");

      //
      // start a new listener
      new socketManager(ds, cm).start();

      // this code manages incoming packets routing them to correct destination
      // It also initializes a new connection
      
      if(dp.getData()[0] == 0) {
        if(config.DEBUG)
          System.out.println("DEBUG (socketManager): Management packet");
        switch(dp.getData()[1]) {
          case 0:   // opening new connection
            if(config.DEBUG)
              System.out.println("DEBUG (socketManager): connection request from "
                                        + dp.getAddress() 
                                        + " port = " 
                                        + dp.getPort());
            {
            // new socket is created and initialized
            MSocket socket = new MSocket(); 

            // socket is activated and inserted in active connections table 
            new queueManager(socket, cm).start();
            cm.put(dp.getAddress(), dp.getPort(), socket); 
            
            // user is notified of incoming connection
            }
            break;
          default:
            if(config.DEBUG)
              System.out.println("DEBUG (socketManager): other "
                                        + dp.getAddress() 
                                        + " port = " 
                                        + dp.getPort());
            {
            MSocket socket = cm.get(dp.getAddress(), dp.getPort());
            socket.getQueue().insert(dp);
            }
            break;
        }
      }
      else {
        if(config.DEBUG)
          System.out.println("DEBUG (socketManager): data packet");

        // packet is routed to correct manager
        
        MSocket socket = cm.get(dp.getAddress(), dp.getPort());
        socket.getQueue().insert(dp);
      }         
    } catch(IOException e) {}
  }    
}        
